package checkers.nonnull;

import javax.annotation.processing.*;
import javax.lang.model.SourceVersion;

import checkers.basetype.BaseTypeChecker;
import checkers.metaquals.TypeQualifiers;
import checkers.quals.*;
import checkers.source.*;

/**
 * A typechecker plug-in for the {@link NonNull} qualifier that finds (and
 * verifies the absence of) null-pointer errors.
 *
 * @manual #nonnull NonNull Checker
 */
@SupportedLintOptions({"flow", "cast", "cast:redundant"})
@SupportedSourceVersion(SourceVersion.RELEASE_7)
@SuppressWarningsKey("nonnull")
@TypeQualifiers({ Nullable.class, Raw.class, NonNull.class })
public class NonNullChecker extends BaseTypeChecker {}
